<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Origin, Content-Type, Accept, Authorization, X-Request-With');
//header('Access-Control-Allow-Credentials: true');

date_default_timezone_set("Asia/Kolkata");
require_once 'include/config.php';

$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';
$response = array();
$cart_item = "";


function updateProductQuantity($connection, $code, $size, $quantity, $productDetails) {
	
	if (!$productDetails) {
		$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$code'")->fetch_assoc();
	}
	
	if($productDetails['product_allsize']) {
		$allSizes = explode(",", $productDetails['product_allsize']);
		$allQuantities = explode(",", $productDetails['quantity']);
		
		foreach ($allSizes as $index => $allSize) {
			if ($size == $allSize) {
				$allQuantities[$index] = $allQuantities[$index] - $quantity;
			}
		}
		
		$finalQuantities = implode(",", $allQuantities);
		$update = $connection->query("UPDATE products SET quantity = '$finalQuantities' WHERE product_code = '$code'");
	} else {
		$update = $connection->query("UPDATE products SET quantity = quantity - $quantity WHERE product_code = '$code'");
	}
}



if ($contentType === "application/json") {
	//Receive the RAW post data.
	$content = trim(file_get_contents("php://input"));
	$decoded = json_decode($content);
	
	/*** $decoded->data will have everything personal ***/
	/*** $decoded->cart will have cart items in it ***/
	/*** $decoded->coupon will have all the coupon details if any ***/
	
	$name = htmlspecialchars($connection->real_escape_string($decoded->data->name));
	$walletUsername = htmlspecialchars($connection->real_escape_string($decoded->data->walletUsername));
	$walletPhone = htmlspecialchars($connection->real_escape_string($decoded->data->walletPhone));
	$walletEmail = htmlspecialchars($connection->real_escape_string($decoded->data->walletEmail));
	$email = htmlspecialchars($connection->real_escape_string($decoded->data->email));
	$phone = htmlspecialchars($connection->real_escape_string($decoded->data->phone));
	$address = htmlspecialchars($connection->real_escape_string($decoded->data->address));
	$altermoblie = htmlspecialchars($connection->real_escape_string($decoded->data->altermoblie));
	$landmark = htmlspecialchars($connection->real_escape_string($decoded->data->landmark));
	$state = htmlspecialchars($connection->real_escape_string($decoded->data->state));
	$city = htmlspecialchars($connection->real_escape_string($decoded->data->city));
	$block = htmlspecialchars($connection->real_escape_string($decoded->data->block));
	$panchayat = htmlspecialchars($connection->real_escape_string($decoded->data->panchayat));
	$pincode = htmlspecialchars($connection->real_escape_string($decoded->data->pincode));
	$uniqueId = htmlspecialchars($connection->real_escape_string($decoded->data->uniqueId));
	$amount = (float)htmlspecialchars($connection->real_escape_string($decoded->data->total));
	$payment_method = htmlspecialchars($connection->real_escape_string($decoded->data->payment_method));
	$delivery_charges = htmlspecialchars($connection->real_escape_string($decoded->data->delivery_charge));
	$type = htmlspecialchars($connection->real_escape_string($decoded->data->type));
	$cat_type = htmlspecialchars($connection->real_escape_string($decoded->data->cat_type));
	$order_type = htmlspecialchars($connection->real_escape_string($decoded->data->order_type));

	$guest_checkout = htmlspecialchars($connection->real_escape_string($decoded->data->guest_checkout));

	$coupon_type = htmlspecialchars($connection->real_escape_string($decoded->data->coupon_type));
	$coupon_discount1 = htmlspecialchars($connection->real_escape_string($decoded->data->coupon_amount));
	$cashback_discount = htmlspecialchars($connection->real_escape_string($decoded->data->cashback_amount));
	$coupon_code = htmlspecialchars($connection->real_escape_string($decoded->data->coupon_code));
	
	$booking_amount = htmlspecialchars($connection->real_escape_string($decoded->data->booking_amount));


	$totalamountdelcou = $amount + $delivery_charges - $coupon_discount1;

	
	$today = date('Y-m-d');
	$order_date = date('Y-m-d H:i:s');
	$order_time = date("h:i:sa");
	
	$soProceed = false;
	$couponDiscount = 0;
	$totalAmount = 0;
	$coupon = null;	
	
	if($coupon_type == 'coupon'){
		$coupon_discount = $coupon_discount1;
	}else{
		$coupon_discount = $cashback_discount;
	}
	


	    $ordcode = $connection->query("SELECT max(id) FROM temporder")->fetch_array();
			$l_id = $ordcode[0]+1;

	
	if (($payment_method == "wallet" && $guest_checkout == "true") || (empty($walletUsername) && $payment_method == "wallet")) {
		$response = array(
			"status" => 5,
			"msg" => "please select payment method again",
		);
		// echo json_encode($response);
		// die();
	}
	
 if (!empty($name) && !empty($phone) && !empty($uniqueId)
		&& !empty($type) && !empty($payment_method) && (!empty($walletUsername) || !empty($guest_checkout))) {
		
		 if ($payment_method == "POD") {
			
			
			foreach ($decoded->cart as $cart_item) {
				
				$p_name = $cart_item->product_name;
				$p_quantity = $cart_item->product_quantity;
				$p_price = $cart_item->product_price;
				$p_code = $cart_item->product_code;
				$p_color = $cart_item->product_color;
				$p_size = $cart_item->product_size;
				$p_gst = $cart_item->product_gst;
				$p_combo = $cart_item->combo_product;
				$product_pic = $cart_item->product_pic;
				$start_date= $cart_item->product_start_date;
				$end_date= $cart_item->product_end_date;
				$appointment= $cart_item->product_appointment;
				$vendor_id= $cart_item->product_vendor;
				$cat_type1 = $cart_item->product_cat_type;
				$product_gram = $cart_item->product_gram;
				$c_img = $cart_item->c_img;
				
				// $item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);
				$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];
				$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

				$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();
				updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);
				
				$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product,color,size,uniqueId,
					transactionId,phone,order_date,product_pic,vendor_id,cat_type,weight,c_img) VALUES ('$p_name','$p_code','$p_price','$p_quantity','$p_combo','$p_color','$p_size','$uniqueId','$uniqueId','$phone','$order_date','$product_pic','$vendor_id','$cat_type1','$product_gram','$c_img');";

					

			}
			$totalAmount = $all_items_total_after_gst;
			$withoutDiscount = $all_item_total_without_coupon_gst;
			
			$sql .= "INSERT INTO temporder (username, name, email, address, landmark, payment_method, phone, alternate_phone, amount,
					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code,coupon_type, shipping_charges, uniqueId,
					payment_status, order_status, txnid, type, order_type, reward, order_date , order_time ,product_pic,product_name,boarding_start_date,boarding_end_date,vet_appointment,pincode,vendor_id,cat_type,state,city,block,panchayat,booking_amount) VALUES('$walletUsername', '$name',
					'$email','$address', '$landmark', 'POD','$phone', '$altermoblie', '$totalamountdelcou','$amount','','',
					'$coupon_discount', '$coupon_code','$coupon_type','$delivery_charges','$uniqueId','Pay On Delivery','In Progress', '$uniqueId',
					'App','Shopping','0','$order_date','$order_time','$product_pic','$p_name','$start_date','$end_date','$appointment','$pincode','$vendor_id','$cat_type','$state','$city','$block','$panchayat','$booking_amount');";

					if($coupon_type == 'cashback'){
						$sql .= "UPDATE user_wallet SET balance = balance + '$coupon_discount' where username = '$walletUsername' ";
					}
			
			$soProceed = true;
		} 

         $idWiseVendor= $connection->query("SELECT vendor_id FROM `temporder` WHERE uniqueId='$uniqueId'")->fetch_assoc();

         $idWiseVendorEmail = $idWiseVendor['vendor_id'];

         $emailWiseVendorPhone = $connection->query("SELECT phone FROM vendor WHERE email='$idWiseVendorEmail'")->fetch_assoc();

         $vendorPhone = $emailWiseVendorPhone['phone'];


		if ($soProceed === true) {
			
			$query = $connection->multi_query($sql);
			
			if ($query === true) {
					$tot = $amount+$delivery_charges;
					$od = $connection->insert_id;
				//newOrderCustomerSMS($phone,$tot,$newCode);
	
				//newOrderVendorSMS($newCode,$vendor_id);

					//newOrderCustomerSMS($phone,$l_id);

					newOrderVendorSMS($l_id,$vendorPhone);
					newOrderAdminSMS($l_id);
				$response = array(
					"status" => 1,
					"msg" => "Success",
					"saq" => $sql,
					"uniqueId" => $uniqueId,
					
					//"orderId" => $connection->insert_id,
					"orderId" => $newCode,
				);
			} else {
				$response = array(
					"status" => 2,
					"msg" => "unexpected error",
					"sql" => $sql,
				);
			}
			
		}
	} else {
		$data = array(
			"status" => 0,
			"msg" => "empty fields",
			'a' => $decoded
		);
	}
} else {
	$response = array(
		"status" => 99,
		"msg" => "unauthorised access",
	);
}
echo json_encode($response);
// echo json_encode($response);
?>
